(function() {

  // conditional OR to pass cached / new assignment *** BEST
  function createElement_1(tagName, attributes) {
    return Element.writeAttribute(
      Element.cache[tagName] ||
        (Element.cache[tagName] =
	      Element.extend(Fuse._doc.createElement(tagName))),
      attributes);
  }

  // conditional OR to skip new assignment *** BETTER
  function createElement_2(tagName, attributes) {
    Element.cache[tagName] ||
	  (Element.cache[tagName] =
	    Element.extend(Fuse._doc.createElement(tagName)));
    return Element.writeAttribute(
      Element.cache[tagName].cloneNode(false), attributes);
  }

  // conditional IF to skip new assignment *** CURRENT
  function createElement_3(tagName, attributes) {
    if (!Element.cache[tagName])
	  Element.cache[tagName] = Element.extend(Fuse._doc.createElement(tagName)); 
    return Element.writeAttribute(Element.cache[tagName]
      .cloneNode(false), attributes);
  }

  function timeElapsed(t) { return ((new Date()).getTime() - t); }

  var i, $tt;

  //-- EX3

  $tt = (new Date).getTime();
  for (i = 0; i < 10000; i++) {
    createElement_3('div');
  }
  document.writeln('createElement_3 took ' + (timeElapsed($tt)) + 'ms *** CURRENT<br/>');

  //-- EX2

  $tt = (new Date).getTime();
  for (i = 0; i < 10000; i++) {
    createElement_2('div');
  }
  document.writeln('createElement_2 took ' + (timeElapsed($tt)) + 'ms *** -------<br/>');

  //-- EX1

  $tt = (new Date).getTime();
  for (i = 0; i < 10000; i++) {
	createElement_1('div');
  }
  document.writeln('createElement_1 took ' + (timeElapsed($tt)) + 'ms *** IMPROVED<br/>');

})();
